package testGrid;
import java.awt.Color;
import unit4.gridLib.*;
public class TestGrid6Queens_8 {
	private final static String QWEEN = ((char)9819)+"";

	public static void main(String[] args) 
	{
		//System.out.println((int)"♛".charAt(0));
		Grid g = new Grid(8, 8, 50, 50);
        int i, j;
        for (i = 0; i < 8; i++)
            for (j = 0; j < 8; j++){
                g.setCellTextColor(i, j, Color.red);
                if ((i + j) % 2 == 0)
                    g.setCellColor(i, j, Color.gray);
        }
        g.flipVertical();
        g.setFontSize(70);
        g.show();
        for (i = 0; i < 8; i++){
        	clear(g);
        	g.setCellText(0, i, QWEEN);
        	setQueens(g, 1);
        	try{
        		System.in.read();
        		System.in.read();
             }
             catch(Exception e){}
        }
	}

	static void clear(Grid g){
        for (int i = 0; i < g.getRowsCount(); i++)
            for (int j = 0; j < g.getColumnsCount(); j++)
                g.setCellText(i, j, "");
	}
	/* A utility function to check if a queen can be placed on grid[row, col]
    Note that this function is called when "row" queens are already placeed
    in rows from 0 to row -1. So we need to check only down side for
    attacking queens */
	static boolean isValid(Grid g, int row, int col)
	{
	
	    int i, j;
	    /* Check this col on down side of grid*/
	    for (i = 0; i < row; i++)
	        if (g.getCellText(i, col) != "")
	            return false;
	   
	    /* Check lower diagonal on left side */
	    i = row - 1;
	    j = col - 1;
	    while (i >= 0 && j >= 0)
	    {
	    	if (g.getCellText(i, j) != "")
	            return false;
	    	i--;
	        j--;
	    }
	    
	    /* Check lower diagonal on right side */
	    i = row - 1;
	    j = col + 1;
	    while (i >= 0 && j < g.getColumnsCount())
	    {
	    	if (g.getCellText(i, j) != "")
	            return false;
	        i--;
	        j++;
	    }
	    return true;
	}
	static boolean setQueens(Grid g, int row)
    {
        int i;
        /* base case: If all queens are placed then return true */
        if (row == g.getRowsCount())
            return true;
        /* Consider this row and try placing this queen in all rows
        one by one */
        for (i = 0; i < g.getColumnsCount(); i++)
        {
            /* Check if queen can be placed on grid in any column i in this row */
            if (isValid(g, row, i))
            {
            	/* Place this queen in  grid in row and column i */
                g.setCellText(row, i, QWEEN);
                try {
					Thread.sleep(50);
				} catch (InterruptedException e) {
					
				}
                /* recur to place rest of the queens */
                if (setQueens(g, row + 1))
                    return true;
                /* If placing queen in grid  doesn't lead to a solution then remove queen from this place */
                g.setCellText(row, i, ""); // BACKTRACKING

            }
        }
        /* If queen can not be place in any column i in this row then return false */
        return false;

    }

}
