package testGrid;
import java.awt.Color;
import java.awt.Point;

import unit4.gridLib.*;
public class TestGrid7KnightsProblem {
	private final static int ALEPH = 1488;
	private final static String KNIGHT = ((char)9816)+"";
	private final static int[][] MOVES = 
		{ { 1, 2 }, { 2, 1 }, { 2, -1 }, { -1, 2 }, { -1, -2 }, { -2, -1 }, { -2, 1 }, { 1, -2 } };
	public static void main(String[] args){
		//System.out.println((int)('♘'));
		int rows = 8;
		int columns = 8;
		int[][] g = new int[rows][columns];
		
		int i, j, ii, jj;
		Grid g1 = new Grid(rows, columns, 50, 50);
		Grid gRows = new Grid(rows, 1, 50, 50);
		Grid gColumns = new Grid(1, columns, 50, 50);
		Grid gCaption = new Grid(1, 1, 50 * (columns + 4), 50);
		for (i = 0; i < rows; i++)
			for (j = 0; j < columns; j++)
			{
				g[i][j] = -1;
				g1.setCellTextColor(i, j, new Color(102,51,0));
				gRows.setCellText(i, 0, "" +(i + 1));
				gColumns.setCellText(0, j, "" + (char)(ALEPH + j) );
				if ((i + j) % 2 == 0)
					g1.setCellColor(i, j, Color.gray);
			}
		gCaption.setFontSize(24);
        g1.setFontSize(24);
        gRows.setFontSize(24);
        gColumns.setFontSize(24);
        Color emptyColor = new Color(0,0,0,0);
        gRows.setGridLinesColor(emptyColor);
        gColumns.setGridLinesColor(emptyColor);
        gCaption.setGridLinesColor(emptyColor);
        gRows.setLocation((int)(gRows.getxLocation() - (columns + 1) * gRows.getCellWidth() / 2.0), (int)gRows.getyLocation());
        gColumns.setLocation((int)gColumns.getxLocation(), (int)(gColumns.getyLocation() - (rows + 1) * gColumns.getCellHeight() / 2.0));
        gCaption.setLocation((int)gCaption.getxLocation(), (int)(gCaption.getyLocation() + (rows + 1) * gCaption.getCellHeight() / 2.0));
        
		g1.show();
		gRows.show();
		gColumns.show();
		gCaption.show();
		boolean solve = solveKnightsProblem(0, 0, 0, g);
		//System.out.println(solve);
		if (solve) {
			gCaption.setCellText(0, 0, "Solution in " + 1 + ", " + (char)(ALEPH));
			g1.setDelay(200);
			for (int nMove = 0; nMove < rows * columns; nMove++) {
				Point loc = findLocation(nMove, g);
				g1.setCellText(loc.y, loc.x, KNIGHT);
				
			}
			
		}
	}
	static Point findLocation(int x, int[][] g){
        for (int i = 0; i < g.length; i++)
            for (int j = 0; j < g[0].length; j++)
                if (g[i][j] == x)
                    return new Point(j, i); // i = column; j = row
        return null;
    }
	 static boolean isValid(int row, int column, int[][] g) {
         return (row >= 0 && row < g.length && column >= 0 && column < g[0].length && g[row][column] == -1);
             
     }
	 static boolean solveKnightsProblem(int row, int column, int movei, int[][] g){
         int rows = g.length;
         int columns = g[0].length;
         g[row][column] = movei;
         if (movei == rows * columns - 1)
             return true;
         int next_row;
         int next_column;
         /* Try all next moves from the current location row, column */
         for (int k = 0; k < MOVES.length; k++)
         {
             next_row = row + MOVES[k][0];
             next_column = column + MOVES[k][1];
             //System.out.println(x);
             if (isValid(next_row, next_column, g)){
                 if (solveKnightsProblem(next_row, next_column, movei + 1, g))
                     return true;

             }
         }
         g[row][column] = -1;
         return false;
     }

}
