package testGrid;
import java.awt.Color;
import java.util.Random;
import unit4.gridLib.*;
public class TestGrid8Maze {

	private final static Random RND = new Random();
	
	public static void main(String[] args) {
		boolean[][] maze = generateMaze(16, 32);
		Grid g = new Grid(maze.length, maze[0].length, 30, 30);
		for (int row = 0; row < maze.length; row++) {
			for (int column = 0; column < maze[0].length; column++) {
				if (maze[row][column])
					g.setCellColor(row, column, Color.black);
				else
					g.setCellColor(row, column, Color.white);
				
			}
		}
		g.show();

	}
	private static int[][] getRandomDirections(){
		int[][] dir = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
		int ind1, ind2, tmp;
		for (int i = 0; i< 50; i++) {
			ind1 = RND.nextInt(dir.length);
			ind2 = RND.nextInt(dir.length);
			tmp = dir[ind1][0];
			dir[ind1][0] = dir[ind2][0];
			dir[ind2][0] = tmp;
			tmp = dir[ind1][1];
			dir[ind1][1] = dir[ind2][1];
			dir[ind2][1] = tmp;
			
		}
		return dir;
	}
	private static boolean[][] generateMaze(int rows, int columns){
		rows = rows + (1 - rows % 2);           // make it odd
		columns = columns + (1 - columns % 2); // make it odd
		boolean[][] maze = new boolean[rows][columns];
		for (int row = 0; row < rows; row++)
		for (int column = 0; column < columns; column++)
			maze[row][column] = true;
		generateMaze(maze, 1, 1);
		return maze;
		}
	private static void generateMaze(boolean[][] maze, int row, int column){
		int rows = maze.length;
		int columns = maze[0].length;
		// Check if current cell is not valid
		if (row < 0 || column < 0 || row >= rows || column >= columns)
			return;
		// Check if current cell is visited
		if (!maze[row][column])
			return;
		// Mark the current cell as visited
		maze[row][column] = false;
		// List of random directions
		int[][] dir = getRandomDirections();
		int next_row;
		int next_column;
		for (int i = 0; i < dir.length; i++){
			next_row = row + 2 * dir[i][0];
			next_column = column + 2 * dir[i][1];
			//System.out.println(dir[i][0] + " " + dir[i][1]);
			if (next_row > 0 && next_column > 0 && next_row < rows && next_column < columns && maze[next_row][next_column]) {
				maze[row + dir[i][0]][column + dir[i][1]] = false;
				generateMaze(maze, next_row, next_column);
			}
;
			
			
		}

	}

}
