package testTurtles;
import unit4.turtleLib.*;


import java.awt.Color;

public class TestTurtle4CurveHilbert 
{

	public static void main(String[] args) 
	{
		Turtle t = new Turtle();
		//t.setDelay(5);
		t.moveBackward(100);
        t.tailDown();
		curveHilbert(t, 6, 10, true);
		t = null;
		t = new Turtle();
		Turtle.clear();
		t.setDelay(5);
		t.setTailColor(Color.red);
		t.tailDown();
		curve(t, 4, 3, true);
		t = new Turtle();
		Turtle.clear();
		t.setDelay(5);
		t.setTailColor(Color.blue);
		t.tailDown();
		sierpinskiCurve(t, 3, 15);
		Turtle.clear();
		t = null;
		Turtle[] turtles;
        turtles = new Turtle[4];
        int i;
        double len = 200;
        for (i = 0; i < 4; i++)
         {
             turtles[i] = new Turtle();
             turtles[i].setDelay(10);
             turtles[i].tailUp();
             turtles[i].turnRight(i * 90);
             turtles[i].moveForward(len / 2.0);
             turtles[i].turnRight(90);
             turtles[i].moveForward(len / 2.0);
             turtles[i].turnRight(90);
             turtles[i].tailDown();
        }
        double alfa = 0;
        double d = 2.0;
        while (len > d)
        {
            for (i = 0; i < 4; i++)
            {
                turtles[i].turnRight(alfa);
                turtles[i].moveForward(d);
            }
            len -= d;
            alfa = Math.atan(d / len);
            alfa = 180 * alfa / Math.PI;
        }

	}
	/* - hilbert curve
    *
    * Author: Pekar Valery
    *
    *   This program is distributed in the hope that it will be useful,
    *   but WITHOUT ANY WARRANTY; without even the implied warranty of
    *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    *
    * The Hilbert Curve is based on the simple recursive pattern:
    *    ____       _   _       _   _
    *   |    |     | |_| |     | | | |
    *   |    | --> |_   _|  ~   _   _  
    *   |    |      _| |_       _| |_
    */
   // The remarkably short Hilbert subroutine draws the Hilbert curve.
   // It takes as parameters the depth of recursion, and dx and dy values that
   // give the direction in which it should draw. It recursively draws four 
   // smaller Hilbert curves and connects them with lines. 
   // The turtle needs only to know of rectangular steps.
	public static void curveHilbert(Turtle turtle, int depth, int steps, boolean left)
    {
        if (depth > 0)
        {
            if (!left)
                turtle.turnLeft(90);
            else
                turtle.turnLeft(-90);
            curveHilbert(turtle, depth - 1, steps, !left);
            turtle.moveForward(steps);

            if (left)
                turtle.turnLeft(90);
            else
                turtle.turnLeft(-90);
            curveHilbert( turtle, depth - 1, steps, left);
            turtle.moveForward(steps);

            curveHilbert(turtle, depth - 1, steps, left);

            if (left)
                turtle.turnLeft(90);
            else
                turtle.turnLeft(-90);
            turtle.moveForward(steps);
            curveHilbert(turtle, depth - 1, steps, !left);

            if (!left)
                turtle.turnLeft(90);
            else
                turtle.turnLeft(-90);
        }
    }
	public static void curve(Turtle turtle, int depth, int steps, boolean left)
    {
        if (depth > 0)
        {

            for (int i = 1; i <= 4; i++)
            {
                if (left)
                {
                	turtle.turnLeft(90);
                    curve(turtle, depth - 1, steps, !left);
                }
                else
                {
                	turtle.turnLeft(-90);
                    curve(turtle, depth - 1, steps, !left);
                }
                turtle.moveForward(Math.pow(3, depth) * steps);
            }


        }
    }
	private static void halfSierpinskiCurve(Turtle turtle, int depth, int steps)
    {
        if (depth == 0)
            turtle.moveForward(steps);
        else //(depth > 0)
        {
            halfSierpinskiCurve(turtle, depth - 1, steps);
            turtle.turnLeft(45);
            turtle.moveForward(steps * Math.sqrt(2));
            turtle.turnLeft(45);
            halfSierpinskiCurve(turtle, depth - 1, steps);
            turtle.turnRight(90);
            turtle.moveForward(steps);
            turtle.turnRight(90);
            halfSierpinskiCurve(turtle, depth - 1, steps);
            turtle.turnLeft(45);
            turtle.moveForward(steps * Math.sqrt(2));
            turtle.turnLeft(45);
            halfSierpinskiCurve(turtle, depth - 1, steps);
        }
    }
	public static void sierpinskiCurve(Turtle turtle, int depth, int steps)
    {
        turtle.turnLeft(45);
        halfSierpinskiCurve(turtle, depth, steps);
        
        turtle.turnRight(90);
        turtle.moveForward(steps);
        turtle.turnRight(90);
        halfSierpinskiCurve(turtle, depth, steps);

        turtle.turnRight(90);
        turtle.moveForward(steps);
        turtle.turnRight(90);
    }
}

